# PiKVM v3.3 Plastic Case for 3D printing
When printing the case, you can choose the following options:

* The presence or absence of an OLED screen (used to display the IP address and other information).

## Buy options

* [Small 5v fan](https://www.amazon.com/GeeekPi-Raspberry-30x30x7mm-Brushless-Retroflag/dp/B07C9C99RM) **strongly recommended** to avoid overheating in the case.
* [I2C OLED screen](https://www.amazon.com/Pieces-Display-Module-SSD1306-Screen/dp/B08TLXYKS6).

## Building

![type:video](https://www.youtube.com/embed/-SRL92VJ870)

## Parts

### The front part

**Choose ONE of them.**

| Variant | Description |
|---------|-------------|
| <img src="case_a_no_oled.png" width=200 /> | [The front part](case_a_no_oled.stl) of the case **WITHOUT a hole** for the OLED |
| <img src="case_a.png" width=200 /> | [The front part](case_a.stl) of the case with a hole **for installing the OLED** |

### The back part

| Variant | Description |
|---------|-------------|
| <img src="case_b.png" width=200 /> | [The back part](case_b.stl) of the case |

### Spacers

| Type | Description |
|------|-------------|
| <img src="spacer_6.2mm.png" width=200 /> | [6.2mm spacer](spacer_6.2mm.stl), required **TWO** pieces |
| <img src="spacer_1mm.png" width=200 /> | [1mm spacer](spacer_1mm.stl) required **TWO** pieces |
| <img src="low_spacer.png" width=200 /> | [Low spacer](low_spacer.stl) required **ONE** piece |
